﻿# -*- coding: utf-8 -*-
#
# スナップショット画像をアニメ化する
# 2014/12/15 アニメファイルの名前の付け方変更
$LOAD_PATH.push(Dir.pwd)
require "gphys_const"
require "gphys_time"
require "my_utils"
require "numru/ggraph"
include NumRu

# 見たいデータファイルの相対パス
dir = '..'

# 重ね書きしたい地形データのある相対パス
#sp_dir = './tmp'
sp_dir = '..'

# 重ね書きしたい地形データ
sp_file = 'sp_for_Mars_T021_MGS'
#sp_file = 'dual_differential_topog'
#sp_file = 'differential_topog'
#sp_file = 'sp_for_Mars_T021_AvarageMGS'

# 重ね書きしたい地形の変数
sp_vname = 'topog'

#vnames = ['SurfTemp', 'OLRA', 'KMHF_d', 'NewmanF_d', 'TauXB', 'TauYB','Tau']
#vnames = ['SurfTemp', 'KMHF_d', 'NewmanF_d','Tau', 'SurfMajCompIce']
vnames = ['SurfTemp', 'KMHF_d',  'SurfMajCompIce', 'DDAF_d', 'Eta', 'SensB','SurfDustGravSedFlux', 'Tau']#, 'Press_top']
#vnames = ['SurfVelAbs']
figdir = 'figs'
ltfigdir = figdir + '/ltfigs'
#Dir::mkdir( figdir )

##$figfile = Dir[ File.expand_path(ltfigdir)+"/*"] #ディレクトリ内のファイルを絶対パスで受け取る
if File.exists?(ltfigdir) then
   system( 'rm -rf ' + 'ltfigs')
##    figfile.each{ |file|
##      next if /^\.+$/ =~ file
##      File.delete(file)}
##    Dir.rmdir(ltfigdir)
##    Dir::mkdir( ltfigdir )
else
    Dir::mkdir( ltfigdir )
end

# 取り出す年
iyrs = 5
iyre = 5
#iyrs = 1
#iyre = 1
# 取り出す時間. 月か直接時間を指定
#lt = [8,9,10]
#lt = [9,10]
#lt = [10]
lt = [270]
#lt = [90]

# 指定時間を直接指定する(appointed)か, 月ごとにする(month)か
#appointed_switch = 'month'
appointed_switch = 'appointed'
# 地形高度を 0 m 地点のみにするか(false), 等高線でしっかり描くか(true)
overwrite_topog_switch = 'true'
# 時間の単位, 時間単位(hour), 秒単位(sec)
unit = 'hour'
#unit = 'sec'

# 時間の切だし 
#hours = dcpam_hours(iyrs, iyre, lt, unit, appointed_switch)

# lt で指定したLs付近で経度 lon が0時になるように合わせたローカルタイムから days 日後までのアニメーションを作る場合
# 何日分取り出すか
days = 20
# ローカルタイム 0 時をどこにとるか
lon = 0
# ls から時間への変換
time_array = ls_to_time(iyrs,iyre, dir, lt)
# 指定したls(時間)付近でローカルタイムが0 時が lon のところの時間を取り出し
lt_array = local_starting_time_and_ending_time(time_array[0], days, lon, dir)
# 時間の切だし 
hours = dcpam_hours(iyrs, iyre, [lt_array], unit, appointed_switch)

if appointed_switch == 'month'
  infix = 'month_'
elsif appointed_switch == 'appointed'
  infix = 'Ls_'
end
imon_order = lt.max.abs.to_i.to_s.length
p hours
for ivar in 0..(vnames.length-1)
  for imon in 0..lt.length-1
    hour_order = (hours[1][imon] - hours[0][imon]).abs.to_i.to_s.length
    array = Array.new(hours[1][imon] - hours[0][imon])
    for hour in hours[0][imon].to_i..hours[1][imon].to_i
      p 'vname: ' + vnames[ivar]
      p 'Month: ' + lt[imon].to_s
      p 'hour: ' + hour.to_s

      system('ruby draw_2D_lt.rb ' + dir + ' ' + vnames[ivar] + ' ' + hour.to_s + ' ' + hours[0][imon].to_s + ' ' + overwrite_topog_switch.to_s + ' ' + sp_dir + ' ' + sp_file + ' ' + sp_vname)# + ' ' + lt[imon].to_s)
      system("pdf2ps dcl.pdf dcl.ps")
      system("rm dcl.pdf")

      system("pstoimg -type gif -flip r270 dcl.ps")
      system("convert dcl.gif -trim dcl.gif")
      com =  "mv dcl.gif "+ltfigdir+"/dcl_"+vnames[ivar]+"_"+infix+"%0#{imon_order}d"%(lt[imon].to_s)+'_'+"lt%0#{hour_order}d"%(hour - hours[0][imon] + 1) + ".gif" 
      system(com)
      com =  "mv dcl.ps  "+ltfigdir+"/dcl_"+vnames[ivar]+"_"+infix+"%0#{imon_order}d"%(lt[imon].to_s)+'_'+"lt%0#{hour_order}d"%(hour - hours[0][imon] + 1) + ".ps" 
      system(com)

      com = ltfigdir+"/dcl_"+vnames[ivar]+"_"+infix+"%0#{imon_order}d"%(lt[imon].to_s)+'_'+"lt%0#{hour_order}d.gif"%(hour - hours[0][imon] + 1)
      array[hour-hours[0][imon]] = com
    end
    tempname = ltfigdir+"/anim_"+vnames[ivar]+"_"+infix+"%0#{imon_order}d"%(lt[imon].to_s)+".gif"
    make_anime(array, 20, tempname)
  end
end

