﻿# -*- coding: utf-8 -*-
#
$LOAD_PATH.push(Dir.pwd)
require 'gphys_const'
require 'gphys_methods'
require 'gphys_time'
require "numru/ggraph"
include NumRu
include NMath

index = 11
type = 1
dir = ARGV[0]
ls_file_dir = ARGV[1]
iyrs = ARGV[2].to_i
iyre = ARGV[3].to_i
vname = ARGV[4]
ls_array = []
ARGV[5].split("_").each do |ls|
  ls_array << ls.to_i
end

#デフォルト値
max = nil
min = nil

time = ls_to_time(iyrs, iyre, ls_file_dir, ls_array)
#p "test5"
DCL.gropn(2)
#DCL.sldiv('y',2,2)           # 2x2に画面分割, 'y'=yoko: 左上→右上→左下...
DCL.sgpset('lcntl', false)   # 制御文字を解釈しない
#DCL.sgpset('lfull',true)     # 全画面表示
DCL.uzfact(0.75)             # 座標軸の文字列サイズを 0.75 倍
#DCL.uzfact(0.7)             # 座標軸の文字列サイズを 0.75 倍
DCL.sgpset('lfprop',true)    # プロポーショナルフォントを使う

DCL.sgscmn(37)

GGraph.set_fig 'window'=>[-90, 90,nil,nil]
GGraph.set_axes('xlabelint'=>10)

  if vname == 'AllRadiation'
    gphys = GPhys::IO.open( dir+'/'+'DTempDtMNIR.nc', 'DTempDtMNIR' )
    gphys2 = GPhys::IO.open( dir+'/'+'DTempDtRadL.nc', 'DTempDtRadL' )
    gphys3 = GPhys::IO.open( dir+'/'+'DTempDtRadS.nc', 'DTempDtRadS' )
    gphyszm = (3700 * 24) * (gphys.cut("time"=>time[0].to_i..time[1].to_i, ) + gphys2.cut("time"=>time[0].to_i..time[1].to_i,) + gphys3.cut("time" =>time[0].to_i..time[1].to_i,)).mean('lon','time')  
    gphyszm.rename("AllRadiation")
    gphyszm.set_att("long_name","Heating rate")
    gphyszm.set_att("units","K day-1")
  elsif vname == 'Budget'
    vnames = ['DTempDtMNIR','DTempDtDryConv','DTempDtMajCompPhaseChange','DTempDtRadL','DTempDtRadS','DTempDtVDiff']
    gphys = GPhys::IO.open( dir+ '/' + 'DTempDtDyn.nc', 'DTempDtDyn')
    gphyszm = (3700 * 24) * gphys.cut("time"=>time[0].to_i..time[1].to_i,).copy
    vnames.each do |vname|
      gphys = GPhys::IO.open( dir+ '/' + vname + '.nc', vname)
      gphysout = (3700 * 24) * gphys.cut("time"=>time[0].to_i..time[1].to_i, "lat"=>lat).copy
      gphyszm = gphyszm + gphysout
    end
    gphyszm = gphyszm.mean("lon","time")
    gphyszm.rename("HeatBudget")
    gphyszm.set_att("long_name","Heating rate")
    gphyszm.set_att("units","K day-1")
  elsif vname == 'DTempDtDyn' || vname == 'DTempDtMNIR' || vname == 'DTempDtDryConv' || vname == 'DTempDtMajCompPhaseChange' || vname == 'DTempDtRadL' || vname == 'DTempDtRadS' || vname == 'DTempDtVDiff'
    gphys = GPhys::IO.open( dir+'/'+vname+'.nc', vname )
    gphyszm = (3700 * 24) * gphys.cut("time"=>time[0].to_i..time[1].to_i, "lat"=>lat).mean('lon','time')
    rename = vname.slice(7..-1)
    gphyszm.rename(rename)
    gphyszm.set_att("long_name","Heating rate")
    gphyszm.set_att("units","K day-1")
  else
    gphys = GPhys::IO.open( dir+'/'+vname+'.nc', vname )
    gphyszm = gphys.cut("time"=>time[0].to_i..time[1].to_i, 'lon'=>0).mean('time')
  end


  if index == 11
    # シグマの範囲を出力

    GGraph.line(gphyszm, true, 'index'=>index, 'type'=>type, 'legend'=>true, 'annotate'=>false, 'title'=>'', 'min'=>min, 'max'=>max)
  elsif index == 51
    # max 値と min 値を表示
    print("vname:", vname,"\n")
    print("max:", gphyszm.max," ")
    print("min:", gphyszm.min,"\n")

    GGraph.line(gphyszm, false, 'index'=>701, 'type'=>type, 'legend'=>true,'annotate'=>false, 'title'=>'', 'min'=>min, 'max'=>max)
  else
    # max 値と min 値を表示
    print("vname:", vname,"\n")
    print("max:", gphyszm.max," ")
    print("min:", gphyszm.min,"\n")

    GGraph.line(gphyszm, false, 'index'=>index, 'type'=>type, 'legend'=>true, 'annotate'=>false, 'title'=>'', 'min'=>min, 'max'=>max)
  end
  index += 10

#DCL::uxmttl('t', 'Heat Balance', 0.0)
#DCL::uxmttl('T', title, -1.0)

DCL.grcls
