﻿# -*- coding: utf-8 -*-
#
$LOAD_PATH.push(Dir.pwd)
require 'gphys_const'
require 'gphys_methods'
require 'gphys_time'
require "numru/ggraph"
include NumRu
include NMath

dir = ARGV[0]
ls_file_dir = ARGV[1]
vname = ARGV[2]
iyrs = ARGV[3].to_i
iyre = ARGV[4].to_i
lat = ARGV[5].to_i
ls_array = []

ARGV[6].split("_").each do |ls|
  ls_array << ls.to_i
end

time = ls_to_time(iyrs, iyre, ls_file_dir, ls_array)

if vname == 'AllRadiation'
  gphys = GPhys::IO.open( dir+'/'+'DTempDtMNIR.nc', 'DTempDtMNIR' )
  gphys2 = GPhys::IO.open( dir+'/'+'DTempDtRadL.nc', 'DTempDtRadL' )
  gphys3 = GPhys::IO.open( dir+'/'+'DTempDtRadS.nc', 'DTempDtRadS' )
##
### 3700 [s] * (x_0 + ... x_23) [K/s] / 1 [day] = 
##  3700 * 1/(24 * 3700) [day] * (24 * 3700) (x_0 + ... x_23) [K/day] / 1[day] = 3700 (x_0 + ... x_23) [K/day]
## を計算する. これは 3700 * (x_0+..x_23)/24 * 24 => 3700 * 24 (x_0 + ... x_23)/24 => 一日 * (x_i.mean('time'))
## if (time[1].to_i - time[0].to_i) % 24 == 0
##   gphysout = gphys[false, 0..(time[1].to_i-time[0].to_i)/24].copy
##   for i in 0..(time[1].to_i - time[0].to_i)/24
##     gphysout[false, i] = gphys.cut("time"=>(time[0].to_i+i*24)..(time[0].to_i+(i+1)*24)).sum("time") + gphys2.cut("time"=>(time[0].to_i + i*24)..(time[0].to_i+(i+1)*24)).sum("time") + gphys3.cut("time"=>(time[0].to_i + i*24)..(time[0].to_i+(i+1)*24)).sum("time")
##   end
## else
##   gphysout = gphys[false, 0..((time[1].to_i-time[0].to_i)/23 + (time[1].to_i - time[0].to_i) % 23)].copy
##   for i in 0..((time[1].to_i - time[0].to_i)/23 + (time[1].to_i - time[0].to_i) % 23)
##     t1 = time[0].to_i + i*24
##     t2 = time[0].to_i + (i + 1)*24
##     gphysout[false, i] = gphys.cut("time"=>t1..t2).sum("time") + gphys2.cut("time"=>t1..t2).sum("time") + gphys3.cut("time"=>t1..t2).sum("time")
##  end
## end
## gphyszm = 3700 * gphysout.mean('lon','time')
  gphyszm = (3700 * 24) * (gphys.cut("time"=>time[0].to_i..time[1].to_i, 'lat'=>lat) + gphys2.cut("time"=>time[0].to_i..time[1].to_i, 'lat'=>lat) + gphys3.cut("time" =>time[0].to_i..time[1].to_i, 'lat'=>lat)).mean('lon','time')  
  gphyszm.rename("AllRadiation")
  gphyszm.set_att("long_name","Radiation Heating")
  gphyszm.set_att("units","K day-1")
elsif vname == 'Budget'
  vnames = ['DTempDtMNIR','DTempDtDryConv','DTempDtMajCompPhaseChange','DTempDtRadL','DTempDtRadS','DTempDtVDiff']
  #vnames = ['DTempDtMNIR','DTempDtRadL','DTempDtRadS','DTempDtVDiff']
  #vnames = ['DTempDtVDiff', 'DTempDtDryConv']
    gphys = GPhys::IO.open( dir+ '/' + 'DTempDtDyn.nc', 'DTempDtDyn')
    #gphys = GPhys::IO.open( dir+ '/' + 'DTempDtDryConv.nc', 'DTempDtDryConv')
  #  gphyszm = (3700 * 24) * gphys.cut("time"=>time[0].to_i..time[1].to_i).mean("lon","time").copy
  #vnames.each do |vname|
  #  gphys = GPhys::IO.open( dir+ '/' + vname + '.nc', vname)
  #  gphysout = (3700 * 24) * gphys.cut("time"=>time[0].to_i..time[1].to_i).mean("lon","time").copy
  #  gphyszm = gphyszm + gphysout
  #end
    gphyszm = (3700 * 24) * gphys.cut("time"=>time[0].to_i..time[1].to_i, 'lat'=>lat).copy
  vnames.each do |vname|
    gphys = GPhys::IO.open( dir+ '/' + vname + '.nc', vname)
    gphysout = (3700 * 24) * gphys.cut("time"=>time[0].to_i..time[1].to_i, 'lat'=>lat).copy
    gphyszm = gphyszm + gphysout
  end
  gphyszm = gphyszm.mean("lon","time")
  gphyszm.rename("HeatBudget")
  gphyszm.set_att("long_name","Heating Budget")
  gphyszm.set_att("units","K day-1")
elsif vname == 'DTempDtDyn' || vname == 'DTempDtMNIR' || vname == 'DTempDtDryConv' || vname == 'DTempDtMajCompPhaseChange' || vname == 'DTempDtRadL' || vname == 'DTempDtRadS' || vname == 'DTempDtVDiff'
  gphys = GPhys::IO.open( dir+'/'+vname+'.nc', vname )
##    if (time[1].to_i - time[0].to_i) % 24 == 0
##      gphysout = gphys[false, 0..(time[1].to_i-time[0].to_i)/24].copy
##      for i in 0..(time[1].to_i - time[0].to_i)/24
##        gphysout[false, i] = gphys.cut("time"=>(time[0].to_i + i*24)..(time[0].to_i+(i+1)*24)).sum("time")
##      end
##    else
##      gphysout = gphys[false, 0..((time[1].to_i-time[0].to_i)/24 + (time[1].to_i - time[0].to_i) % 24)].copy
##      for i in 0..((time[1].to_i - time[0].to_i)/24 + (time[1].to_i - time[0].to_i) % 24)
##        t1 = time[0].to_i + i *24
##        t2 = time[0].to_i+(i+1)*24
##        gphysout[false, i] = gphys.cut("time"=>t1..t2).sum("time")
##      end
##    end
##  gphyszm = 3700 * gphysout.mean('lon','time')
  gphyszm = (3700 * 24) * gphys.cut("time"=>time[0].to_i..time[1].to_i, 'lat'=>lat).mean('lon','time')
  gphyszm.set_att("units","K day-1")
else
  gphys = GPhys::IO.open( dir+'/'+vname+'.nc', vname )
  gphyszm = gphys.cut("time"=>time[0].to_i..time[1].to_i, 'lat'=>lat).mean('lon','time')
end

#p "test1"

rmiss = gphys.get_att('missing_value')[0]
#gphys = nan_to_rmiss(gphys, rmiss)

# max 値と min 値を表示
print("max:", gphyszm.max)
print("min:", gphyszm.min)

DCL.gropn(2)
#DCL.sldiv('y',2,2)           # 2x2に画面分割, 'y'=yoko: 左上→右上→左下...
DCL.sgpset('lcntl', false)   # 制御文字を解釈しない
#DCL.sgpset('lfull',true)     # 全画面表示
DCL.uzfact(0.75)             # 座標軸の文字列サイズを 0.75 倍
#DCL.uzfact(0.7)             # 座標軸の文字列サイズを 0.75 倍
DCL.sgpset('lfprop',true)    # プロポーショナルフォントを使う

#DCL.glpset('lmiss',true)
#DCL.glpset('rmiss',rmiss)
DCLExt.gl_set_params('lmiss'=>true)

#< GGraph による 描画 >
#GGraph.set_fig 'itr'=>2,'window'=>[nil,nil,800,500]
GGraph.set_fig('itr'=>2, 'window'=>[nil,nil,1000,500])
GGraph.set_axes('ylabelint'=>100)

#p levels.length
#p patterns.length
GGraph.line( gphyszm.cut("level"=>1000..500), true, 'index'=>29,'exchange'=>true, 'annotate'=>false)

DCL::uxmttl('T', ' ', 1.0)
#DCL::uxmttl('T', title, -1.0)

DCL.grcls
