﻿# coding: utf-8
#
# 東西平均, Ls を決め打ちして時間平均した加熱率の鉛直プロファイル(圧力座標) ディレクトリで指定したものを重ね書く(K/day - level)
$LOAD_PATH.push(Dir.pwd)
require 'gphys_const'
require 'gphys_methods'
require "numru/ggraph"
include NumRu

ls_file_dir = '..'
dirs = ['../../dcpam_M_dust_T21L36_const_0.3_20140630_AverageSP_37-48_MPI/util_s2p-2014-06-20/out', '../../dcpam_M_dust_T21L36_const_0.3_20140630_OnlyTop_37-48_MPI/util_s2p-2014-06-20/out', '../../dcpam_M_dust_T21L36_const_0.3_20140630_ZonalMean_37-48_MPI/util_s2p-2014-06-20/out']
name_var = '_ASP_and_OT_and_ZM_'
#name_end = '_surface'
name_end = '_more_high_range'
legend_array = ['flat', 'observation', 'zonal_SPACE_mean']
#legend_array = ['true'] # 単純に変数を凡例にしたいときは true のみを入れる _SPACE_と書いてある場合は半角スペースに変換する
index_array = ['21', '11', '41']
#index_array = ['true'] # 単純に線の色を11 (黒色) から10毎に変えていきたい場合は true のみを入れる

daysOfYear = 0
DaysOfMonth.each do |i|
  daysOfYear += i
end
p 'DEBUG: days in a year: ' + daysOfYear.to_s

figdir = 'figs'
#Dir::mkdir( figdir )

#vnames = ['Temp', 'U', 'MSF', 'QVap', 'ANGMOM', 'DustDensScledOptDep','Dust','DOD067']
#vnames = ['DTempDtDryConv','DTempDtDyn','DTempDtMNIR','DTempDtMajCompPhaseChange','DTempDtRadL','DTempDtRadS','DTempDtVDiff']
vnames = ['MSF']
#vnames = ['DTempDtRadL']
#vnames = ['DTempDtDyn', 'DTempDtMNIR']
#vnames = ['DTempDtMNIR','DTempDtRadL','DTempDtRadS']
#vnames = ['TKE', 'TKEDiss','TKEPBuoy','TKEPShear']
#vnames = ['DOD067','HeatFlux','MomFluxX','MomFluxY']
#vnames = ['SigDot','Geopotential','V']

iyrs = 4
iyre = 4
#iyrs = 1
#iyre = 1
#ls_array = ['266','272']
ls_array = ['86','92']

#lat = ['-25']
lat = ['25']

all_radiation_switch = true # true の場合 RadL, RadS, MNIR を一つのものにまとめる
#all_radiation_switch  = false
check_buget_switch = true # true の場合 DTempDt をすべて足してみる Budget を出力する

if all_radiation_switch
  vname_new = []
  vnames.each do |vname|
    if vname == 'DTempDtMNIR' || vname == 'DTempDtRadL' || vname == 'DTempDtRadS'
      vname_new << 'AllRadiation'
    else
      vname_new << vname
    end
  end
  vname_new.uniq!
  vnames = vname_new
end

tmp_switch = false
if check_buget_switch
  vname_new = []
  vnames.each do |vname|
    if vname =~ /DTempDt*/
      tmp_switch = true
    end
    vname_new << vname
  end
  if tmp_switch
    vname_new << 'Budget'
  end
  vname_new.uniq!
  vnames = vname_new
end


for ivar in 0..(vnames.length-1)
#  for imon in 1..12
for ilat in 0..(lat.length-1)
    p vnames[ivar] + ' at Year: ' + iyrs.to_s + ' to ' + iyre.to_s + ' at lat: ' + lat[ilat].to_s + ' seeing: ' + name_end

    system('ruby draw_3D_zm_k_per_day-log_individual_overwrite.rb ' + ls_file_dir + ' ' + vnames[ivar] + ' ' + iyrs.to_s + ' ' + iyre.to_s + ' ' + lat[ilat].to_s + ' ' + ls_array.join("_") + ' ' + dirs.join("!") + ' ' + legend_array.join("!") + ' ' + index_array.join("_"))
    system("pdf2ps dcl.pdf dcl.ps")
    system("rm dcl.pdf")

#    system("dclpsrmcm dcl.ps | dclpsrot | dclpsmargin > kari")
    system("dclpsrmcm dcl.ps | dclpsmargin > kari")
    system("mv kari dcl.ps")
    system("pstoimg -type gif -flip r270 dcl.ps")
    system("convert dcl.gif -trim dcl.gif")
    com = sprintf( "mv dcl.gif " + figdir + "/dcl_zm_k_per_day-log"+ name_var + vnames[ivar].to_s + "_overwrite" + '_lat' + lat[ilat].to_s + '_' + ls_array[0].to_s + "-" + ls_array[1].to_s + name_end + ".gif" )
    system(com)
    com = sprintf( "mv dcl.ps " + figdir + "/dcl_zm_k_per_day-log"+name_var + vnames[ivar].to_s + "_overwrite" + '_lat' + lat[ilat].to_s + '_' + ls_array[0].to_s + "-" + ls_array[1].to_s + name_end + ".ps" )
    system(com)
  end
end
