﻿# -*- coding: utf-8 -*-
#
$LOAD_PATH.push(Dir.pwd)
require 'gphys_const'
require 'gphys_methods'
require 'gphys_time'
require "numru/ggraph"
include NumRu
include NMath

index = 11
type = 1
dir = ARGV[0]
ls_file_dir = ARGV[1]
iyrs = ARGV[2].to_i
iyre = ARGV[3].to_i
lat = ARGV[4].to_i
vname_array = []
ls_array = []
ARGV[5].split("_").each do |vname|
  vname_array << vname.to_s
end
ARGV[6].split("_").each do |ls|
  ls_array << ls.to_i
end

#デフォルト値
max = nil
min = nil
sig_min = 1
sig_min = 0

#Ls270,lat-25
#surface
#sig_min=1
#sig_max=0.987
#ASP
#max=1250
#min=-1650
#OT
#max=1350
#min=-1800
#ZM
#max=1350
#min=-1800

##Ls90,lat25
##surface
#sig_min=1
#sig_max=0.987
##ASP
#max=1100
#min=-1100
##OT
#max=1100
#min=-1100
##ZM
##max=800
#max=1000
#min=-1000
#
##more_high
#sig_min = 0.987
#sig_max = 0.0002821174
##ASP
#max=35
#min=-35
##OT
#max=30
#min=-30
##ZM
#max=40
#min=-40
#
#top
sig_min = 0.0002821174
sig_max = 0
#ASP
#max=20
#min=-20
#OT
max=25
min=-25
#ZM
#max=15
#min=-15


time = ls_to_time(iyrs, iyre, ls_file_dir, ls_array)
#p "test5"
DCL.gropn(2)
#DCL.sldiv('y',2,2)           # 2x2に画面分割, 'y'=yoko: 左上→右上→左下...
DCL.sgpset('lcntl', false)   # 制御文字を解釈しない
#DCL.sgpset('lfull',true)     # 全画面表示
DCL.uzfact(0.75)             # 座標軸の文字列サイズを 0.75 倍
#DCL.uzfact(0.7)             # 座標軸の文字列サイズを 0.75 倍
DCL.sgpset('lfprop',true)    # プロポーショナルフォントを使う

DCL.sgscmn(37)

GGraph.set_fig 'window'=>[min, max,sig_min,sig_max]

vname_array.each do |vname|
  if vname == 'AllRadiation'
    gphys = GPhys::IO.open( dir+'/'+'DTempDtMNIR.nc', 'DTempDtMNIR' )
    gphys2 = GPhys::IO.open( dir+'/'+'DTempDtRadL.nc', 'DTempDtRadL' )
    gphys3 = GPhys::IO.open( dir+'/'+'DTempDtRadS.nc', 'DTempDtRadS' )
    ##
    ### 3700 [s] * (x_0 + ... x_23) [K/s] / 1 [day] = 
    ##  3700 * 1/(24 * 3700) [day] * (24 * 3700) (x_0 + ... x_23) [K/day] / 1[day] = 3700 (x_0 + ... x_23) [K/day]
    ## を計算する. これは 3700 * (x_0+..x_23)/24 * 24 => 3700 * 24 (x_0 + ... x_23)/24 => 一日 * (x_i.mean('time'))
    ## if (time[1].to_i - time[0].to_i) % 24 == 0
    ##   gphysout = gphys[false, 0..(time[1].to_i-time[0].to_i)/24].copy
    ##   for i in 0..(time[1].to_i - time[0].to_i)/24
    ##     gphysout[false, i] = gphys.cut("time"=>(time[0].to_i+i*24)..(time[0].to_i+(i+1)*24)).sum("time") + gphys2.cut("time"=>(time[0].to_i + i*24)..(time[0].to_i+(i+1)*24)).sum("time") + gphys3.cut("time"=>(time[0].to_i + i*24)..(time[0].to_i+(i+1)*24)).sum("time")
    ##   end
    ## else
    ##   gphysout = gphys[false, 0..((time[1].to_i-time[0].to_i)/23 + (time[1].to_i - time[0].to_i) % 23)].copy
    ##   for i in 0..((time[1].to_i - time[0].to_i)/23 + (time[1].to_i - time[0].to_i) % 23)
    ##     t1 = time[0].to_i + i*24
    ##     t2 = time[0].to_i + (i + 1)*24
    ##     gphysout[false, i] = gphys.cut("time"=>t1..t2).sum("time") + gphys2.cut("time"=>t1..t2).sum("time") + gphys3.cut("time"=>t1..t2).sum("time")
    ##  end
    ## end
    ## gphyszm = 3700 * gphysout.mean('lon','time')
    gphyszm = (3700 * 24) * (gphys.cut("time"=>time[0].to_i..time[1].to_i, "lat"=>lat) + gphys2.cut("time"=>time[0].to_i..time[1].to_i, "lat"=>lat) + gphys3.cut("time" =>time[0].to_i..time[1].to_i, "lat"=>lat)).mean('lon','time')  
    gphyszm.rename("AllRadiation")
    gphyszm.set_att("long_name","Heating rate")
    gphyszm.set_att("units","K day-1")
  elsif vname == 'Budget'
    vnames = ['DTempDtMNIR','DTempDtDryConv','DTempDtMajCompPhaseChange','DTempDtRadL','DTempDtRadS','DTempDtVDiff']
    #vnames = ['DTempDtMNIR','DTempDtRadL','DTempDtRadS','DTempDtVDiff']
    #vnames = ['DTempDtVDiff', 'DTempDtDryConv']
    gphys = GPhys::IO.open( dir+ '/' + 'DTempDtDyn.nc', 'DTempDtDyn')
    #gphys = GPhys::IO.open( dir+ '/' + 'DTempDtDryConv.nc', 'DTempDtDryConv')
    #  gphyszm = (3700 * 24) * gphys.cut("time"=>time[0].to_i..time[1].to_i).mean("lon","time").copy
    #vnames.each do |vname|
    #  gphys = GPhys::IO.open( dir+ '/' + vname + '.nc', vname)
    #  gphysout = (3700 * 24) * gphys.cut("time"=>time[0].to_i..time[1].to_i).mean("lon","time").copy
    #  gphyszm = gphyszm + gphysout
    #end
    gphyszm = (3700 * 24) * gphys.cut("time"=>time[0].to_i..time[1].to_i, "lat"=>lat).copy
    vnames.each do |vname|
      gphys = GPhys::IO.open( dir+ '/' + vname + '.nc', vname)
      gphysout = (3700 * 24) * gphys.cut("time"=>time[0].to_i..time[1].to_i, "lat"=>lat).copy
      gphyszm = gphyszm + gphysout
    end
    gphyszm = gphyszm.mean("lon","time")
    gphyszm.rename("HeatBudget")
    gphyszm.set_att("long_name","Heating rate")
    gphyszm.set_att("units","K day-1")
  elsif vname == 'DTempDtDyn' || vname == 'DTempDtMNIR' || vname == 'DTempDtDryConv' || vname == 'DTempDtMajCompPhaseChange' || vname == 'DTempDtRadL' || vname == 'DTempDtRadS' || vname == 'DTempDtVDiff'
    gphys = GPhys::IO.open( dir+'/'+vname+'.nc', vname )
    ##    if (time[1].to_i - time[0].to_i) % 24 == 0
    ##      gphysout = gphys[false, 0..(time[1].to_i-time[0].to_i)/24].copy
    ##      for i in 0..(time[1].to_i - time[0].to_i)/24
    ##        gphysout[false, i] = gphys.cut("time"=>(time[0].to_i + i*24)..(time[0].to_i+(i+1)*24)).sum("time")
    ##      end
    ##    else
    ##      gphysout = gphys[false, 0..((time[1].to_i-time[0].to_i)/24 + (time[1].to_i - time[0].to_i) % 24)].copy
    ##      for i in 0..((time[1].to_i - time[0].to_i)/24 + (time[1].to_i - time[0].to_i) % 24)
    ##        t1 = time[0].to_i + i *24
    ##        t2 = time[0].to_i+(i+1)*24
    ##        gphysout[false, i] = gphys.cut("time"=>t1..t2).sum("time")
    ##      end
    ##    end
    ##  gphyszm = 3700 * gphysout.mean('lon','time')
    gphyszm = (3700 * 24) * gphys.cut("time"=>time[0].to_i..time[1].to_i, "lat"=>lat).mean('lon','time')
    rename = vname.slice(7..-1)
    gphyszm.rename(rename)
    gphyszm.set_att("long_name","Heating rate")
    gphyszm.set_att("units","K day-1")
  else
    gphys = GPhys::IO.open( dir+'/'+vname+'.nc', vname )
    gphyszm = gphys.cut("time"=>time[0].to_i..time[1].to_i, "lat"=>lat).mean('lon','time')
  end


  if index == 11
    # シグマの範囲を出力
    print("sig_min:",gphyszm.axis("sig").to_gphys.cut("sig"=>sig_min).val,"\n")
    print("sig_max:",gphyszm.axis("sig").to_gphys.cut("sig"=>sig_max).val,"\n")
    # max 値と min 値を表示
    print("vname:", vname,"\n")
    print("max:", gphyszm.cut("sig"=>sig_min..sig_max).max," ")
    print("min:", gphyszm.cut("sig"=>sig_min..sig_max).min,"\n")

    GGraph.line(gphyszm.cut("sig"=>sig_min..sig_max), true, 'index'=>index, 'type'=>type, 'legend'=>true, 'exchange'=>true, 'annotate'=>false, 'title'=>'', 'min'=>min, 'max'=>max)
  elsif index == 51
    # max 値と min 値を表示
    print("vname:", vname,"\n")
    print("max:", gphyszm.cut("sig"=>sig_min..sig_max).max," ")
    print("min:", gphyszm.cut("sig"=>sig_min..sig_max).min,"\n")

    GGraph.line(gphyszm.cut("sig"=>sig_min..sig_max), false, 'index'=>701, 'type'=>type, 'legend'=>true, 'exchange'=>true, 'annotate'=>false, 'title'=>'', 'min'=>min, 'max'=>max)
  else
    # max 値と min 値を表示
    print("vname:", vname,"\n")
    print("max:", gphyszm.cut("sig"=>sig_min..sig_max).max," ")
    print("min:", gphyszm.cut("sig"=>sig_min..sig_max).min,"\n")

    GGraph.line(gphyszm.cut("sig"=>sig_min..sig_max), false, 'index'=>index, 'type'=>type, 'legend'=>true, 'exchange'=>true, 'annotate'=>false, 'title'=>'', 'min'=>min, 'max'=>max)
  end
  index += 10
end

DCL::uxmttl('t', 'Heat Balance', 0.0)
#DCL::uxmttl('T', title, -1.0)

DCL.grcls
