﻿#!/usr/bin/env ruby
# -*- coding: utf-8 -*-
#これはTauXB.ncとTauYB.ncから|Tau|を作るスクリプトである
# 2012/10/15 荻原弘尭

#-------------宣言文-------------------
require "numru/gphys"
require "../gphys_tmp_calc"
require "../my_utils"
include NumRu
include Math

#-------------ファイル定義--------------
heightfilename = "../../Height.nc"
surfheightfilename = "../../sp_for_Mars_T021_OnlyTop_MGS.nc"
surftempfilename = "../../SurfTemp.nc"
tempfilename = "../../Temp.nc"
psfilename = "../../Ps.nc"
n2filename = "../tmp/N2.nc"
pottempfilename = "../../PotTemp.nc"
#-------------変数定義-------------------
height = GPhys::IO.open(heightfilename, 'Height')
surfheight = GPhys::IO.open(surfheightfilename, 'topog')
surftemp = GPhys::IO.open(surftempfilename, 'SurfTemp')
temp = GPhys::IO.open(tempfilename, 'Temp')
pottemp = GPhys::IO.open(pottempfilename, 'PotTemp')
ps = GPhys::IO.open(psfilename, 'Ps')
sig = GPhys::IO.open(psfilename, 'sig')
sigm = GPhys::IO.open(psfilename, 'sigm')
imax,jmax,kmax,tmax = temp.shape

xyz_N2 = NArray.float(imax,jmax,kmax)
#--------------計算----------------------
timecount = temp.coord(-1).val
n2file = NetCDF.create(n2filename)
temp_vir = NetCDF.open(tempfilename, mode="r")
temp_vir.each_dim do |dim|
  n2file.def_dim(dim.name, dim.length_ul0)
end
temp_vir.each_var do |var|
  n2file.redef 
  if var.name == 'Temp'
   n2 = n2file.def_var('N2', var.vartype, var.dims)
   n2.put_att("long_name", "Stratification (N^2)")
   n2.put_att("units", "s-2")
  else
    n2 = n2file.def_var(var.name, var.vartype, var.dims)
    for i in 0..var.att_names.size - 1
      n2.put_att(var.att(var.att_names[i]).name, var.att(var.att_names[i]).get)
    end
  end
  n2file.enddef
  if var.name == 'time'
  elsif var.dim_names.index('time').nil?
    n2.put(var.get)
  else
    axnames = var.dim_names.size-1
    index = 0
    z_tempinpol = []
    z_tepinpol = tempInpol(sig, sigm)
    time = n2file.var(var.dim_names[-1])
    array1 = Array.new(axnames,0)
    array2 = Array.new(axnames,0)
    timecount.each do |times|
      array1.fill(0,0..-1).push(index)
      array2.fill(-1,0..-1).push(index)
      for k in 0..kmax-2
      p "t = ", times
        p "k = ", k
        if k == 0
      xyz_N2[false,k] = surfN2(ps[false,times], sigm[0], sig[0], surftemp[false,times], temp[false,k,times], height[false,k,times], surfheight[i,j]).val
        else
          r_temp = z_tempinpol[0][k] * temp[false,k] + z_tempinpol[1][k] * temp[false,k+1]
          r_exner = make_exner(ps[false,times], sigm[k])
          xyz_N2[false,k] = Grav / (r_temp[false,true] / r_exner[false,true]) * ( pottemp[false, k+1,times] - pottemp[false, k, times]) / (height[false, k+1, times] - height[false, k, times])
        end
        p xyz_N2[false,k]
      end
      xyz_N2[false,kmax-1] = 0.0

      n2.put(xyr_N2, "start"=>array1, "end"=>array2)
      time.put(times, "index"=>[index])
      array1.delete_at(-1)
      array2.delete_at(-1)
      index = index + 1
    end
  end
end
n2file.redef
temp_vir.each_att do |global|
  n2file.put_att(global.name, global.get)
end
n2file.enddef
temp_vir.close
n2file.close
